                               /*===============*/
/*-----------------------------/  D E F I N E S  /----------------------------*/
                               /*===============*/


/*------------------*/
/*  SOURCE OPTIONS  */
/*------------------*/

#define  K_BITRATE       2     /*  2 Ticks pro Sample   */
#define  K_PRNPORT  0x03BD     /*  Status-Reg Prn-Port  */

/*--------------*/
/*  DATA-TYPES  */
/*--------------*/

typedef        signed char  schr;    /*   SCHR:  7-BIT + SIGN    */
typedef      unsigned char  uchr;    /*   UCHR:  8-BIT UNSIGNED  */
typedef        signed int   sint;    /*   SINT: 15-BIT + SIGN    */
typedef      unsigned int   uint;    /*   UINT: 16-BIT UNSIGNED  */
typedef long   signed int  slint;    /*  SLINT: 31-BIT + SIGN    */
typedef long unsigned int  ulint;    /*  ULINT: 32-BIT UNSIGNED  */

/*----------------*/
/*  HEADER-FILES  */
/*----------------*/

#include "dos.h"      /* Cpu & Dos Interfacing */
#include "stdio.h"    /* Buffered File IO-System */
#include "stdlib.h"   /* Standard Library Header */
#include "string.h"   /* String & Memory Funktions */

/*--------------*/
/*  PROTOTYPES  */
/*--------------*/

uchr  getrausch  (void);
ulint bios_ticks (void);

/*-=-=-=-=-=-=-=-*/
/*  GLOBAL DATA  */
/*-=-=-=-=-=-=-=-*/

ulint last_time;

uint bitbuf, bitcnt;

uint linecol;

                             /********************/
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-/   START RAUSCHBIT  /-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
                             /********************/


main () {
  uint n,m;
  FILE *fp;
  puts ("Zufall Pc-Interface - Daten-Sammlung:");
  last_time = bios_ticks();
  bitbuf=bitcnt=linecol=0;
  fp = fopen ("F:\RAUSCH.BIN","wb");
  while (1) {
    n = getrausch ();
    if (n==0xFF) {
      fclose (fp);
      return 0; }
    bitbuf = bitbuf<<1 | n;
    bitcnt++;
    if (bitcnt==8) {
      m = bitbuf >> 4;
      putchar (m>9 ? 'A'+m-10 : '0'+m);
      m = bitbuf & 0x000F;
      putchar (m>9 ? 'A'+m-10 : '0'+m);
      fwrite (&bitbuf,1,1,fp);
      bitbuf=bitcnt=0;
      linecol+=2;
      if (linecol==64) {
        puts ("");
        linecol=0; } } } }


uchr getrausch () {
  ulint n;
  uchr z;
  do {
    if (kbhit()) return 0xFF;
    n = bios_ticks (); }
  while (n-last_time<K_BITRATE);
  z = inportb (K_PRNPORT) >> 7;
  last_time = n;
  return z; }


ulint bios_ticks () {
  ulint n, far *bticks;
  bticks = (ulint far *) MK_FP(0x0040,0x006C);
  disable ();
  n = *bticks;
  enable ();
  n &= 0x00FFFFFF;
  return n; }
